#include <iostream>
#include <string>

// Function that returns an rvalue reference to a passed-in object
std::string&& returnXvalue(std::string& str) {
    return std::move(str);  // Return an xvalue (rvalue reference)
}

int main() {
    std::string original = "Original String";
    std::string&& rvalueRef = returnXvalue(original);  // 'returnXvalue' returns an xvalue

    std::cout << "rvalueRef: " << rvalueRef << std::endl;

    // Modifying the rvalue reference
    rvalueRef = "Modified String";
    std::cout << "original: " << original << std::endl;  // Original object is modified

    return 0;
}

